Index: trunk/sources/HeuristicLab 3.3.sln
===================================================================
--- trunk/sources/HeuristicLab 3.3.sln	(revision 4234)
+++ trunk/sources/HeuristicLab 3.3.sln	(revision 4235)
@@ -87,5 +87,4 @@
 		{A51DA44F-CB35-4F6F-99F5-2A2E904AB93B} = {A51DA44F-CB35-4F6F-99F5-2A2E904AB93B}
 		{2C36CD4F-E5F5-43A4-801A-201EA895FE17} = {2C36CD4F-E5F5-43A4-801A-201EA895FE17}
-		{6024D74F-E29C-4E6B-843E-8851831B8E14} = {6024D74F-E29C-4E6B-843E-8851831B8E14}
 		{3EAF1454-086D-44A2-8509-B1BA24DB1865} = {3EAF1454-086D-44A2-8509-B1BA24DB1865}
 		{2C429157-9C34-4DD3-9D5F-B444B751E39A} = {2C429157-9C34-4DD3-9D5F-B444B751E39A}
@@ -110,6 +109,4 @@
 		{D767C38D-8014-46B0-9A32-03A3AECCE34A} = {D767C38D-8014-46B0-9A32-03A3AECCE34A}
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71} = {BF7D9494-A586-457B-8DF9-ED599F9E6A71}
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7} = {C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}
-		{9B6EA19A-F894-4E00-B5A3-970514284772} = {9B6EA19A-F894-4E00-B5A3-970514284772}
 		{F409DD9E-1E9C-4EB1-AA3A-9F6E987C6E58} = {F409DD9E-1E9C-4EB1-AA3A-9F6E987C6E58}
 		{15452B9F-A436-4139-8EE7-DA72FB8D3664} = {15452B9F-A436-4139-8EE7-DA72FB8D3664}
@@ -129,5 +126,4 @@
 		{66D249C3-A01D-42A8-82A2-919BC8EC3D83} = {66D249C3-A01D-42A8-82A2-919BC8EC3D83}
 		{236459CE-80CF-4991-972F-DE74C826BCCC} = {236459CE-80CF-4991-972F-DE74C826BCCC}
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515} = {2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}
 		{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B} = {102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}
 		{13CA37D6-4111-4E7B-BE2E-AF3DE462D384} = {13CA37D6-4111-4E7B-BE2E-AF3DE462D384}
@@ -137,5 +133,4 @@
 		{1B3063DB-D71C-4A6A-A359-883E8F53A140} = {1B3063DB-D71C-4A6A-A359-883E8F53A140}
 		{DDFB14DD-2A85-493C-A52D-E69729BBAEB0} = {DDFB14DD-2A85-493C-A52D-E69729BBAEB0}
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803} = {B3310CE1-0C05-410F-BA77-8DAD6CE3F803}
 		{88B9B0E3-344E-4196-82A3-0F9732506FE8} = {88B9B0E3-344E-4196-82A3-0F9732506FE8}
 		{AE5B1CE5-9862-4D6F-A700-D72CD9AEA295} = {AE5B1CE5-9862-4D6F-A700-D72CD9AEA295}
@@ -316,17 +311,7 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Algorithms.NSGA2-3.3", "HeuristicLab.Algorithms.NSGA2\3.3\HeuristicLab.Algorithms.NSGA2-3.3.csproj", "{15452B9F-A436-4139-8EE7-DA72FB8D3664}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.DataAnalysis.MultiVariate-3.3", "HeuristicLab.Problems.DataAnalysis.MultiVariate\3.3\HeuristicLab.Problems.DataAnalysis.MultiVariate-3.3.csproj", "{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.DataAnalysis.MultiVariate.Regression-3.3", "HeuristicLab.Problems.DataAnalysis.MultiVariate.Regression\3.3\HeuristicLab.Problems.DataAnalysis.MultiVariate.Regression-3.3.csproj", "{6024D74F-E29C-4E6B-843E-8851831B8E14}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.DataAnalysis.MultiVariate.Views-3.3", "HeuristicLab.Problems.DataAnalysis.MultiVariate.Views\3.3\HeuristicLab.Problems.DataAnalysis.MultiVariate.Views-3.3.csproj", "{9B6EA19A-F894-4E00-B5A3-970514284772}"
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.DataAnalysis.FeatureSelection-3.3", "HeuristicLab.Problems.DataAnalysis.FeatureSelection\3.3\HeuristicLab.Problems.DataAnalysis.FeatureSelection-3.3.csproj", "{7252890C-F207-4AD6-B3C9-764DF93F73CC}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ExternalEvaluation.GP-3.3", "HeuristicLab.Problems.ExternalEvaluation.GP\3.3\HeuristicLab.Problems.ExternalEvaluation.GP-3.3.csproj", "{E86E215D-E3CE-4244-978D-555D4E17AC09}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis-3.3", "HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis\3.3\HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis-3.3.csproj", "{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis.Views-3.3", "HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis.Views\3.3\HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis.Views-3.3.csproj", "{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ExternalEvaluation.GP.Views-3.3", "HeuristicLab.Problems.ExternalEvaluation.GP.Views\3.3\HeuristicLab.Problems.ExternalEvaluation.GP.Views-3.3.csproj", "{1778134B-866B-4CB3-BFC0-52B2FAAA5777}"
@@ -2064,64 +2049,4 @@
 		{15452B9F-A436-4139-8EE7-DA72FB8D3664}.Silverlight2|x64.ActiveCfg = Release|Any CPU
 		{15452B9F-A436-4139-8EE7-DA72FB8D3664}.Silverlight2|x86.ActiveCfg = Release|Any CPU
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Debug|x64.ActiveCfg = Debug|x64
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Debug|x64.Build.0 = Debug|x64
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Debug|x86.ActiveCfg = Debug|x86
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Debug|x86.Build.0 = Debug|x86
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Release|Any CPU.Build.0 = Release|Any CPU
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Release|x64.ActiveCfg = Release|x64
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Release|x64.Build.0 = Release|x64
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Release|x86.ActiveCfg = Release|x86
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Release|x86.Build.0 = Release|x86
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Services|Any CPU.ActiveCfg = Release|x86
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Services|x64.ActiveCfg = Release|x86
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Services|x86.ActiveCfg = Release|x86
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Services|x86.Build.0 = Release|x86
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Silverlight2|Any CPU.ActiveCfg = Release|x86
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Silverlight2|x64.ActiveCfg = Release|x86
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Silverlight2|x86.ActiveCfg = Release|x86
-		{2B88DCD0-EE28-4DCA-90A8-2F4ECACFC515}.Silverlight2|x86.Build.0 = Release|x86
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Debug|x64.ActiveCfg = Debug|x64
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Debug|x64.Build.0 = Debug|x64
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Debug|x86.ActiveCfg = Debug|x86
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Debug|x86.Build.0 = Debug|x86
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Release|Any CPU.Build.0 = Release|Any CPU
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Release|x64.ActiveCfg = Release|x64
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Release|x64.Build.0 = Release|x64
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Release|x86.ActiveCfg = Release|x86
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Release|x86.Build.0 = Release|x86
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Services|Any CPU.ActiveCfg = Release|x86
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Services|x64.ActiveCfg = Release|x86
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Services|x86.ActiveCfg = Release|x86
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Services|x86.Build.0 = Release|x86
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Silverlight2|Any CPU.ActiveCfg = Release|x86
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Silverlight2|x64.ActiveCfg = Release|x86
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Silverlight2|x86.ActiveCfg = Release|x86
-		{6024D74F-E29C-4E6B-843E-8851831B8E14}.Silverlight2|x86.Build.0 = Release|x86
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Debug|x64.ActiveCfg = Debug|x64
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Debug|x64.Build.0 = Debug|x64
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Debug|x86.ActiveCfg = Debug|x86
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Debug|x86.Build.0 = Debug|x86
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Release|Any CPU.Build.0 = Release|Any CPU
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Release|x64.ActiveCfg = Release|x64
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Release|x64.Build.0 = Release|x64
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Release|x86.ActiveCfg = Release|x86
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Release|x86.Build.0 = Release|x86
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Services|Any CPU.ActiveCfg = Release|x86
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Services|x64.ActiveCfg = Release|x86
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Services|x86.ActiveCfg = Release|x86
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Services|x86.Build.0 = Release|x86
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Silverlight2|Any CPU.ActiveCfg = Release|x86
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Silverlight2|x64.ActiveCfg = Release|x86
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Silverlight2|x86.ActiveCfg = Release|x86
-		{9B6EA19A-F894-4E00-B5A3-970514284772}.Silverlight2|x86.Build.0 = Release|x86
 		{7252890C-F207-4AD6-B3C9-764DF93F73CC}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{7252890C-F207-4AD6-B3C9-764DF93F73CC}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -2164,44 +2089,4 @@
 		{E86E215D-E3CE-4244-978D-555D4E17AC09}.Silverlight2|x64.Build.0 = Release|x64
 		{E86E215D-E3CE-4244-978D-555D4E17AC09}.Silverlight2|x86.ActiveCfg = Release|x64
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Debug|x64.ActiveCfg = Debug|x64
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Debug|x64.Build.0 = Debug|x64
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Debug|x86.ActiveCfg = Debug|x86
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Debug|x86.Build.0 = Debug|x86
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Release|Any CPU.Build.0 = Release|Any CPU
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Release|x64.ActiveCfg = Release|x64
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Release|x64.Build.0 = Release|x64
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Release|x86.ActiveCfg = Release|x86
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Release|x86.Build.0 = Release|x86
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Services|Any CPU.ActiveCfg = Release|x86
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Services|x64.ActiveCfg = Release|x86
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Services|x86.ActiveCfg = Release|x86
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Services|x86.Build.0 = Release|x86
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Silverlight2|Any CPU.ActiveCfg = Release|x86
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Silverlight2|x64.ActiveCfg = Release|x86
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Silverlight2|x86.ActiveCfg = Release|x86
-		{B3310CE1-0C05-410F-BA77-8DAD6CE3F803}.Silverlight2|x86.Build.0 = Release|x86
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Debug|x64.ActiveCfg = Debug|x64
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Debug|x64.Build.0 = Debug|x64
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Debug|x86.ActiveCfg = Debug|x86
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Debug|x86.Build.0 = Debug|x86
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Release|Any CPU.Build.0 = Release|Any CPU
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Release|x64.ActiveCfg = Release|x64
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Release|x64.Build.0 = Release|x64
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Release|x86.ActiveCfg = Release|x86
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Release|x86.Build.0 = Release|x86
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Services|Any CPU.ActiveCfg = Release|x86
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Services|x64.ActiveCfg = Release|x86
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Services|x86.ActiveCfg = Release|x86
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Services|x86.Build.0 = Release|x86
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Silverlight2|Any CPU.ActiveCfg = Release|x86
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Silverlight2|x64.ActiveCfg = Release|x86
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Silverlight2|x86.ActiveCfg = Release|x86
-		{C60DF094-ABC1-4313-AD82-E2EAD3FC8DF7}.Silverlight2|x86.Build.0 = Release|x86
 		{1778134B-866B-4CB3-BFC0-52B2FAAA5777}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{1778134B-866B-4CB3-BFC0-52B2FAAA5777}.Debug|Any CPU.Build.0 = Debug|Any CPU