Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 4239)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 4240)
@@ -94,4 +94,5 @@
         foreach (T item in Content)
           AddListViewItem(CreateListViewItem(item));
+        AdjustListViewColumnSizes();
         if ((selectedIndex != -1) && (selectedIndex < itemsListView.Items.Count))
           itemsListView.Items[selectedIndex].Selected = true;
@@ -157,5 +158,4 @@
         ((T)listViewItem.Tag).ToStringChanged += new EventHandler(Item_ToStringChanged);
       }
-      AdjustListViewColumnSizes();
     }
     protected virtual void InsertListViewItem(int index, ListViewItem listViewItem) {
@@ -165,5 +165,4 @@
         ((T)listViewItem.Tag).ToStringChanged += new EventHandler(Item_ToStringChanged);
       }
-      AdjustListViewColumnSizes();
     }
     protected virtual void RemoveListViewItem(ListViewItem listViewItem) {
@@ -349,4 +348,5 @@
         foreach (IndexedItem<T> item in e.Items)
           InsertListViewItem(item.Index, CreateListViewItem(item.Value));
+        AdjustListViewColumnSizes();
 
         for (int i = 0; i < selected.Length; i++)
@@ -378,4 +378,5 @@
         foreach (IndexedItem<T> item in e.Items)
           InsertListViewItem(item.Index, CreateListViewItem(item.Value));
+        AdjustListViewColumnSizes();
       }
     }
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 4239)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 4240)
@@ -70,4 +70,5 @@
         foreach (T item in Content)
           AddListViewItem(CreateListViewItem(item));
+        AdjustListViewColumnSizes();
         SortItemsListView(SortOrder.Ascending);
       }
@@ -124,5 +125,4 @@
       ((T)listViewItem.Tag).ItemImageChanged += new EventHandler(Item_ItemImageChanged);
       ((T)listViewItem.Tag).ToStringChanged += new EventHandler(Item_ToStringChanged);
-      AdjustListViewColumnSizes();
       sortAscendingButton.Enabled = itemsListView.Items.Count > 1;
       sortDescendingButton.Enabled = itemsListView.Items.Count > 1;
@@ -263,7 +263,10 @@
       if (InvokeRequired)
         Invoke(new CollectionItemsChangedEventHandler<T>(Content_ItemsAdded), sender, e);
-      else
+      else {
         foreach (T item in e.Items)
           AddListViewItem(CreateListViewItem(item));
+        AdjustListViewColumnSizes();
+      }
+
     }
     protected virtual void Content_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<T> e) {
@@ -274,6 +277,5 @@
           //remove only the first matching ListViewItem, because the IItem could be contained multiple times in the ItemCollection
           ListViewItem listviewItem = GetListViewItemsForItem(item).FirstOrDefault();
-          if (listviewItem != null)
-            RemoveListViewItem(listviewItem);
+          if (listviewItem != null) RemoveListViewItem(listviewItem);
         }
       }
@@ -286,6 +288,5 @@
           //remove only the first matching ListViewItem, because the IItem could be contained multiple times in the ItemCollection
           ListViewItem listviewItem = GetListViewItemsForItem(item).FirstOrDefault();
-          if (listviewItem != null)
-            RemoveListViewItem(listviewItem);
+          if (listviewItem != null) RemoveListViewItem(listviewItem);
         }
         foreach (T item in e.Items)
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 4239)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 4240)
@@ -97,4 +97,5 @@
         foreach (T item in Content)
           AddListViewItem(CreateListViewItem(item));
+        AdjustListViewColumnSizes();
         if ((selectedIndex != -1) && (selectedIndex < itemsListView.Items.Count))
           itemsListView.Items[selectedIndex].Selected = true;
@@ -158,5 +159,4 @@
       ((T)listViewItem.Tag).ItemImageChanged += new EventHandler(Item_ItemImageChanged);
       ((T)listViewItem.Tag).ToStringChanged += new EventHandler(Item_ToStringChanged);
-      AdjustListViewColumnSizes();
     }
     protected virtual void InsertListViewItem(int index, ListViewItem listViewItem) {
@@ -164,5 +164,4 @@
       ((T)listViewItem.Tag).ItemImageChanged += new EventHandler(Item_ItemImageChanged);
       ((T)listViewItem.Tag).ToStringChanged += new EventHandler(Item_ToStringChanged);
-      AdjustListViewColumnSizes();
     }
     protected virtual void RemoveListViewItem(ListViewItem listViewItem) {
@@ -321,7 +320,9 @@
       if (InvokeRequired)
         Invoke(new CollectionItemsChangedEventHandler<IndexedItem<T>>(Content_ItemsAdded), sender, e);
-      else
+      else {
         foreach (IndexedItem<T> item in e.Items)
           InsertListViewItem(item.Index, CreateListViewItem(item.Value));
+        AdjustListViewColumnSizes();
+      }
     }
     protected virtual void Content_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<T>> e) {
@@ -351,4 +352,5 @@
         foreach (IndexedItem<T> item in e.Items)
           InsertListViewItem(item.Index, CreateListViewItem(item.Value));
+        AdjustListViewColumnSizes();
 
         for (int i = 0; i < selected.Length; i++)
@@ -380,4 +382,5 @@
         foreach (IndexedItem<T> item in e.Items)
           InsertListViewItem(item.Index, CreateListViewItem(item.Value));
+        AdjustListViewColumnSizes();
       }
     }