Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/Service References/ServerService/HeuristicLab.Hive.Contracts1.xsd
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/Service References/ServerService/HeuristicLab.Hive.Contracts1.xsd	(revision 4254)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/Service References/ServerService/HeuristicLab.Hive.Contracts1.xsd	(revision 4263)
@@ -2,23 +2,42 @@
 <xs:schema xmlns:ser="http://schemas.microsoft.com/2003/10/Serialization/" xmlns:tns="http://schemas.datacontract.org/2004/07/HeuristicLab.Hive.Contracts" elementFormDefault="qualified" targetNamespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Hive.Contracts" xmlns:xs="http://www.w3.org/2001/XMLSchema">
   <xs:import namespace="http://schemas.microsoft.com/2003/10/Serialization/" />
-  <xs:import namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Hive.Contracts.BusinessObjects" />
-  <xs:import namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.PluginInfrastructure" />
-  <xs:complexType name="Response">
-    <xs:sequence>
-      <xs:element minOccurs="0" name="StatusMessage" nillable="true" type="xs:string" />
-      <xs:element minOccurs="0" name="Success" type="xs:boolean" />
-    </xs:sequence>
-  </xs:complexType>
-  <xs:element name="Response" nillable="true" type="tns:Response" />
-  <xs:complexType name="ResponseHeartBeat">
-    <xs:complexContent mixed="false">
-      <xs:extension base="tns:Response">
-        <xs:sequence>
-          <xs:element minOccurs="0" name="ActionRequest" nillable="true" type="tns:ArrayOfMessageContainer" />
-        </xs:sequence>
-      </xs:extension>
-    </xs:complexContent>
-  </xs:complexType>
-  <xs:element name="ResponseHeartBeat" nillable="true" type="tns:ResponseHeartBeat" />
+  <xs:simpleType name="ResponseStatus">
+    <xs:restriction base="xs:string">
+      <xs:enumeration value="Ok" />
+      <xs:enumeration value="RequestSnapshot_JobIsNotBeeingCalculated" />
+      <xs:enumeration value="RequestSnapshot_SnapshotAlreadyRequested" />
+      <xs:enumeration value="GetJobById_JobDoesNotExist" />
+      <xs:enumeration value="GetJobByIdWithDetails_JobDoesNotExist" />
+      <xs:enumeration value="AddNewJob_JobStateMustBeOffline" />
+      <xs:enumeration value="AddNewJob_JobIdMustNotBeSet" />
+      <xs:enumeration value="AddNewJob_JobNull" />
+      <xs:enumeration value="RemoveJob_JobDoesNotExist" />
+      <xs:enumeration value="GetLastSerializedResult_JobResultNotYetThere" />
+      <xs:enumeration value="AbortJob_JobDoesNotExist" />
+      <xs:enumeration value="AbortJob_AbortAlreadyRequested" />
+      <xs:enumeration value="AbortJob_JobIsNotBeeingCalculated" />
+      <xs:enumeration value="GetCalendar_ResourceNotFound" />
+      <xs:enumeration value="GetCalendar_NoCalendarFound" />
+      <xs:enumeration value="SetCalendarStatus_ResourceNotFound" />
+      <xs:enumeration value="ProcessHeartBeat_UserNotLoggedIn" />
+      <xs:enumeration value="GetJob_NoJobsAvailable" />
+      <xs:enumeration value="ProcessJobResult_JobDoesNotExist" />
+      <xs:enumeration value="ProcessJobResult_JobAborted" />
+      <xs:enumeration value="ProcessJobResult_JobIsNotBeeingCalculated" />
+      <xs:enumeration value="ProcessJobResult_WrongClientForJob" />
+      <xs:enumeration value="ProcessJobResult_InvalidJobState" />
+      <xs:enumeration value="Login_LoginFaild" />
+      <xs:enumeration value="Logout_SlaveNotRegistered" />
+      <xs:enumeration value="IsJobStillNeeded_JobDoesNotExist" />
+      <xs:enumeration value="IsJobStillNeeded_JobAlreadyFinished" />
+      <xs:enumeration value="GetPlugins_PluginsNotAvailable" />
+      <xs:enumeration value="AddClientGroup_SlaveIdMustNotBeSet" />
+      <xs:enumeration value="AddResourceToGroup_SlaveGroupDoesNotExist" />
+      <xs:enumeration value="DeleteResourceFromGroup_SlaveGroupDoesNotExist" />
+      <xs:enumeration value="GetAllGroupsOfResource_ResourceNotFound" />
+      <xs:enumeration value="DeleteClientGroup_SlaveGroupDoesNotExist" />
+    </xs:restriction>
+  </xs:simpleType>
+  <xs:element name="ResponseStatus" nillable="true" type="tns:ResponseStatus" />
   <xs:complexType name="ArrayOfMessageContainer">
     <xs:sequence>
@@ -50,61 +69,3 @@
   </xs:simpleType>
   <xs:element name="MessageContainer.MessageType" nillable="true" type="tns:MessageContainer.MessageType" />
-  <xs:complexType name="ResponseObjectOfJobDtoZAa7YIsz">
-    <xs:annotation>
-      <xs:appinfo>
-        <GenericType Name="ResponseObjectOf{0}{#}" Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Hive.Contracts" xmlns="http://schemas.microsoft.com/2003/10/Serialization/">
-          <GenericParameter Name="JobDto" Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Hive.Contracts.BusinessObjects">
-          </GenericParameter>
-        </GenericType>
-      </xs:appinfo>
-    </xs:annotation>
-    <xs:complexContent mixed="false">
-      <xs:extension base="tns:Response">
-        <xs:sequence>
-          <xs:element xmlns:q1="http://schemas.datacontract.org/2004/07/HeuristicLab.Hive.Contracts.BusinessObjects" minOccurs="0" name="Obj" nillable="true" type="q1:JobDto" />
-        </xs:sequence>
-      </xs:extension>
-    </xs:complexContent>
-  </xs:complexType>
-  <xs:element name="ResponseObjectOfJobDtoZAa7YIsz" nillable="true" type="tns:ResponseObjectOfJobDtoZAa7YIsz" />
-  <xs:complexType name="ResponseResultReceived">
-    <xs:complexContent mixed="false">
-      <xs:extension base="tns:Response">
-        <xs:sequence>
-          <xs:element minOccurs="0" name="Finished" type="xs:boolean" />
-          <xs:element minOccurs="0" name="JobId" type="ser:guid" />
-        </xs:sequence>
-      </xs:extension>
-    </xs:complexContent>
-  </xs:complexType>
-  <xs:element name="ResponseResultReceived" nillable="true" type="tns:ResponseResultReceived" />
-  <xs:complexType name="ResponseListOfCachedHivePluginInfoDtoZMwZop09">
-    <xs:annotation>
-      <xs:appinfo>
-        <GenericType Name="ResponseListOf{0}{#}" Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Hive.Contracts" xmlns="http://schemas.microsoft.com/2003/10/Serialization/">
-          <GenericParameter Name="CachedHivePluginInfoDto" Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.PluginInfrastructure">
-          </GenericParameter>
-        </GenericType>
-      </xs:appinfo>
-    </xs:annotation>
-    <xs:complexContent mixed="false">
-      <xs:extension base="tns:Response">
-        <xs:sequence>
-          <xs:element xmlns:q2="http://schemas.datacontract.org/2004/07/HeuristicLab.PluginInfrastructure" minOccurs="0" name="List" nillable="true" type="q2:ArrayOfCachedHivePluginInfoDto" />
-        </xs:sequence>
-      </xs:extension>
-    </xs:complexContent>
-  </xs:complexType>
-  <xs:element name="ResponseListOfCachedHivePluginInfoDtoZMwZop09" nillable="true" type="tns:ResponseListOfCachedHivePluginInfoDtoZMwZop09" />
-  <xs:complexType name="ResponseCalendar">
-    <xs:complexContent mixed="false">
-      <xs:extension base="tns:Response">
-        <xs:sequence>
-          <xs:element xmlns:q3="http://schemas.datacontract.org/2004/07/HeuristicLab.Hive.Contracts.BusinessObjects" minOccurs="0" name="Appointments" nillable="true" type="q3:ArrayOfAppointmentDto" />
-          <xs:element minOccurs="0" name="ForceFetch" type="xs:boolean" />
-        </xs:sequence>
-      </xs:extension>
-    </xs:complexContent>
-  </xs:complexType>
-  <xs:element name="ResponseCalendar" nillable="true" type="tns:ResponseCalendar" />
 </xs:schema>